<?php
require_once("init.php");

// LECTURE VARIABLES TRANSMISES
$lang = LireVariable("lang","fr");
$action = LireVariable("action","");
$where = LireVariable("where","");
$choix = LireVariable("choix","");
$total = LireVariable("total",0);
$requete = LireVariable("requete","");
$sort = LireVariable("sort",$tri[0][0]);
$ecran = LireVariable("ecran","");
$fiche = LireVariable("fiche","");

// EXPORTATION DES DONNEES
if ( $action ) {
	
	// LECTURE PANIER SI NECESSAIRE
	$panier = "";
	if ( !$fiche && !$requete ) {
		$panier = (isset($_COOKIE['operation'])) ? $_COOKIE['operation'] : "";
		$panier = preg_replace('/^,(.*),$/',"\\1",$panier);
	}

	// QUOI EXPORTER ?
	$limit = "";
	// LA REQUETE
	if ( $requete ) {
		
		if ( !$where ) $where = "te_operation.Idope>0";
		$limit = " LIMIT 0,".$max_exp;
	
	// UNE OPERATION UNIQUE
	} elseif ($fiche) {
		
		$where = 'te_operation.Idope='.$fiche;

	// LE PANIER
	} elseif ($panier) {	
	
		$where = 'te_operation.Idope='.str_replace(',', ' OR te_operation.Idope=', $fiche);

	} else {
		
		echo "<html><body><center><font class=\"message\">".t('aucune_selection')."</font><br /><br />";
		echo '<form><input class="bouton" type="button" onClick="FermeFenetre();" value="'.t('fermer').'"></form>';
		echo '</center></body></html>';
		exit;

	}
	
	// REQUETE
	if ( $choix == "1" ) {
		$sql = "SELECT * FROM te_operation LEFT OUTER JOIN te_lex_pays ON te_operation.OpeISO = te_lex_pays.Iso3 LEFT OUTER JOIN te_lex_operation ON te_operation.OpeCodeEnquete = te_lex_operation.CodeOperation";
		if ( $where ) $sql .= ' WHERE '.str_replace('','"',$where);
		$sql .= " ORDER BY te_lex_pays.PaysFR,te_operation.Idope,te_operation.OpeCodeIreda";
	} else {
		$sql = "SELECT * ".Jointure("te_operation");
		if ( $where ) $sql .= ' WHERE '.str_replace('','"',$where);
		if ( $sort ) $sql .= " ORDER BY ".$sort;
	}
	Message($sql);
	$resultat = mysql_query($sql);
	$nbenr = mysql_num_rows($resultat);
	
	// FORMATS
	$filename = "";
	switch ( $choix ) {
		
		case "1":	// DDI
					
			// BOUCLE LECTURE
			while ( ($rec = mysql_fetch_assoc($resultat)) ) {
				
				// OUVERTURE FICHIER DE SORTIE
				if ( !$filename ) {
					$filename = $rec["OpeCodeIreda"].".xml";
					if ( $debug || $ecran ) {
						header("Content-type: application/xml");
					} else {
						header("Content-type: application/txt");
						header("Content-disposition:  attachment; filename=\"$filename\"");
					}
					echo '<?xml version="1.0" encoding="UTF-8"?>';
				}
				include("formats/operation_ddi.php");
			}
			break;
			
		case "2": // RDF

			// BOUCLE LECTURE
			while ( ($rec = mysql_fetch_array($resultat)) ) {
				
				// OUVERTURE FICHIER DE SORTIE
				if ( !$filename ) {
					$filename = "export_dc_".$rec["OpeCodeIreda"].".rdf";
					if ( $debug || $ecran ) {
						header("Content-type: application/xml");
					} else {
						header("Content-type: application/txt");
						header("Content-disposition:  attachment; filename=\"$filename\"");
					}
					echo "<?xml version='1.0' encoding='UTF-8'?>\n";
					echo "<rdf:RDF xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" xmlns:dc=\"http://purl.org/dc/elements/1.1/\" xmlns:dcterms=\"http://purl.org/dc/terms/\">\n";
				}
				include("formats/operation_rdf.php");
			}
			echo "</rdf:RDF>\n";
			break;
			
		case "3":	// ENDNOTE
			$sepchp = "\t";
			$seprec = "\r\n";
			
			// CHARGE BORDEREAU
			if (!file_exists("bordereau/endnote.php")) {
				echo "Format d'export [endnote] inconnu.<br />";
				exit;
			}
			require("bordereau/endnote.php");

			// BOUCLE LECTURE
			while ( $rec = mysql_fetch_array($resultat) ) {
				
				// OUVERTURE FICHIER DE SORTIE
				if ( !$filename ) {
					$filename = "endnote_".$rec["OpeCodeIreda"].".txt";
					if ( $debug || $ecran ) {
						echo "<pre>";
					} else {
						header("Content-type: application/txt");
						header("Content-disposition:  attachment; filename=\"$filename\"");
					}
				}

				foreach ($modele as $v) {
					$tmp = stripslashes($rec[$v["chp"]]);
					if ( !empty($tmp) ) {
						$tmp = str_replace("#","<br />", $tmp);
						if ( $v["repetitif"] == 1 ) {
							if ( substr($tmp,0,1) == '|' ) $tmp = substr($tmp,1);
							if ( substr($tmp,-1) == '|' ) $tmp = substr($tmp,0,-1);
							$tmp = str_replace('|', ';', $tmp);
							$article = explode(";",$tmp);
							$adr = ( $v["chp"] == "ResFIC" ) ? "http://".URL."ressources/" : "";
							for ($i=0;$i<count($article);$i++) {
								$tmp = trim($article[$i]);
								if ( $tmp ) echo $v["libelle"]." ".$adr.$tmp.$seprec;
							}
						} else {
							echo $v["libelle"]." ".$tmp.$seprec;	
						}							
					}
				}
				echo $seprec;
			}
			if ( $debug || $ecran ) echo "</pre>";
			break;
	}
	exit;
}

// ENTETE HTML
$css = "style";
$js = "";
require "include/header_fenetre.php";
?>
<form method="post" action="format_export_operation.php">
<table cellspacing="1" cellpadding="0" class="display" align="center" border="0" width="100%">
<tr><th colspan="2"><br /><?php echo t('choix_format'); ?><br /><br /></th></tr>
<tr><td valign="top"><input type="radio" name="choix" value="1" checked></td><td><?php echo t('export_xml'); ?></td></tr>
<tr><td valign="top"><input type="radio" name="choix" value="2"></td><td><?php echo t('export_rdf'); ?></td></tr>
<tr><td valign="top"><input type="radio" name="choix" value="3"></td><td><?php echo t('export_endnote'); ?></td></tr>
<tr><td align="right" colspan="2"><?php echo t('affichage_ecran'); ?><input type="checkbox" value="oui" name="ecran"></td></tr>
</table>
<br />
<p align="right">
	<input class="bouton" type="button" onClick="FermeFenetre();" value="<?php echo t('abandonner'); ?>">&nbsp;
	<input class="bouton" type="submit" name="action" value="<?php echo t('exporter'); ?>">
</p>
<input type="hidden" name="where" value="<?php echo $where; ?>">
<input type="hidden" name="total" value="<?php echo $total; ?>">
<input type="hidden" name="fiche" value="<?php echo $fiche; ?>">
<input type="hidden" name="requete" value="<?php echo $requete; ?>">
<input type="hidden" name="sort" value="<?php echo $sort; ?>">
</form>
</body></html>
