<?php
$restreint = true;
require_once("init.php");

// LECTURE VARIABLES TRANSMISES
$etape = LireVariable("etape","");
$sepchp = LireVariable("sepchp","\t");
$seprec = LireVariable("seprec","\r\n");
$entete = LireVariable("entete","");
$fichier = LireVariable("fichier","");
$champs = LireVariable("champs","");
$total = LireVariable("total",0);
$table = LireVariable("table","");
$ecrase = LireVariable("ecrase","");

// CONSTANTES
$bordereau = str_replace("te_","",$table);
$erreur = "";

// ENTETE HTML
include("include/header_fenetre.php");
echo "<h1>".t('importation')."</h1>";

// ETAPE 1 = PHASE D'ANALYSE
if ( $etape == "Analyse" && isset($_FILES['import_file'])) {
	
	// RECUPERATION DU FICHIER
	$dossier = 'tmp/';
	$fichier = basename($_FILES['import_file']['name']);
	$taille = filesize($_FILES['import_file']['tmp_name']);
	$extension = strrchr($_FILES['import_file']['name'], '.');
	if( $extension != ".txt" ) {
     $erreur = sprintf(t('extension_interdite'),".txt");
	} elseif ( $taille > MAXUPLOAD ) {
     $erreur = sprintf(t('fichier_trop_grand'),MAXUPLOAD);
	} else { 
		$fichier = "fic".date("Y-m-d-H-i-s").".txt"; // NOM DE FICHIER TEMPORAIRE
    if( move_uploaded_file($_FILES['import_file']['tmp_name'], $dossier . $fichier) ) {
      echo t('upload_ok');
    } else {
      echo t('upload_pb');
      $erreur = t('transfert_echoue');
    }
	}
	if ( !$erreur ) {
		// CHARGE BORDEREAU
		if (!file_exists("bordereaux/$lang/$bordereau.php")) {
			echo t('bordereau_inconnu')." [$lang/$bordereau].<br />";
			exit;
		}
		include("bordereaux/$lang/$bordereau.php");
		
		// SEPARATEURS NON AFFICHABLES
		$sepchp = str_replace('\t',"\t",$sepchp);
		$sepchp = str_replace('\r',"\r",$sepchp);
		$sepchp = str_replace('\n',"\n",$sepchp);
		$seprec = str_replace('\t',"\t",$seprec);
		$seprec = str_replace('\r',"\r",$seprec);
		$seprec = str_replace('\n',"\n",$seprec);

		// LECTURE DU PREMIER RECORD
		$fd = fopen ($dossier.$fichier , "r");
		$record = stream_get_line($fd, 4096, $seprec); 
		fclose ($fd);
		$liste = "<select name=\"champs[]\" style=\"width: 200px;\">";
		$liste .= "<option value=\"\">".t('supprimer_contenu')."</option>";
		$i=0;
		foreach ($modele as $k => $v) {
			$tmp = ( $v["repetitif"] == 2 ) ? "*" : "";
			if ( $entete ) {
				$nom = strtoupper(str_replace("<br />"," ",$v["libelle"]));
				$nom = strtr($nom, "ݟ","AAAAAACEEEEIIIIOOOOOUUUUDYYNN"); 
				$liste .= "<option value=\"".$k.$tmp."\"#".$nom."#>".str_replace("<br />"," ",$v["libelle"]);
			} else {
				$liste .= "<option value=\"".$k.$tmp."\">".str_replace("<br />"," ",$v["libelle"]);
			}
			if ( $tmp ) $liste .= " ($tmp)";
			$liste .= "</option>";
			$i++;
		}
		$liste .= "</select>";
		$champ = explode($sepchp,$record);
		
		echo '<form method="post" name="GRILLE">';
		echo '<input type="hidden" name="etape" value="Importation">';
		echo '<input type="hidden" name="sepchp" value="'.$sepchp.'">';
		echo '<input type="hidden" name="seprec" value="'.$seprec.'">';
		echo '<input type="hidden" name="entete" value="'.$entete.'">';
		echo '<input type="hidden" name="table" value="'.$table.'">';
		echo '<input type="hidden" name="fichier" value="'.$dossier.$fichier.'">';	
		echo '<input type="hidden" name="total" value="'.(count($champ)+1).'">';	

		// MAPPING
		echo '<table class="display" align="center" border="0" width="100%"><tr><th colspan="2">';
		echo (count($champ))." ".t('colonne_reconnue')."</th></tr>";
		echo '<tr><th width="50%">'.t('element_reconnu').'</th><th width="50%">'.t('transferer_dans').'</th></tr>';
		
		for ( $i=0; $i < count($champ); $i++) {
			$nom = strtoupper($champ[$i]);
			$nom = strtr($nom,'','AAAAACEEEEIIIINOOOOOUUUUY');
			$listeaff = str_replace("#".$nom."#"," selected",$liste);
			$listeaff = preg_replace("/#[^#]*#/","",$listeaff);
			echo '<tr><td align="right">'.$champ[$i].'</td><td> -> '.$listeaff.'</td></tr>';
		}
		
		// PURGER LE LEXIQUE AVANT CHARGEMENT
		echo '<tr><td align="right">'.t('purger_lexique').'</td><td>';
		echo ' <input type="radio" name="ecrase" value="1" checked> '.t('oui');
		echo '<input type="radio" name="ecrase" value=""> '.t('non');
		echo '</td></tr></table>';
		
		echo '<table width="100%">';
		echo '<tr><td align="right">';
		echo '<input class="bouton" type="button" onClick="FermeFenetre();" value="'.t('fermer').'">&nbsp;';
		echo '<input class="bouton" type="submit" value="'.t('lancer_importation').'"></td></tr>';
		echo '</table></form>';
		echo '</body></html>';
		exit;
	}
}

// ETAPE 2 = PHASE D'IMPORTATION
if ( $etape == "Importation" ) {

	// PURGE DU LEXIQUE
	if ( $ecrase ) {
		$sql = "TRUNCATE TABLE $table;";
		Message($sql);
		$resultat = mysql_query($sql) or die(mysql_error());
		echo '<font class="message">-=> '.t('reinitialisation_lexique').' [<b>'.$table.'</b>]</font><br /><br />';
	}
	
	// CHAMPS A IMPORTER
	$champ = explode(";",$champs);
	$liste = "(Cle";
	for ( $j=0; $j < count($champ); $j++) {
		if ( $champ[$j] ) $liste .= ",".$champ[$j];
	} 
	$liste .= ")";
	$liste = str_replace("*","",$liste);
	ignore_user_abort();
	ob_end_flush();

	$fd = fopen ($fichier , "r");
	$i = 0;
	$pb = 0;
	$ok = 0;
	while (!feof ($fd)) {
		$record = stream_get_line($fd, 4096, $seprec); 
		$chp = explode($sepchp,$record);
		if ( count($chp) != count($champ) ) {
			echo "<font class='message'>-=> ".t('enregistrement')." n$i : <i>[".$record."]</i> ".t('nombre_colonnes_incorrect')." - [".(count($chp))." ".t('nombre_colonnes_trouvees').", ".(count($champ))." ".t('nombre_colonnes_attendues')."]</font><br />";
			$pb++;
		} elseif ( !$entete ) {
			$i++;
			$sql = "INSERT INTO $table $liste VALUES (0";
			for ( $j=0; $j < count($champ); $j++) {
				if ( $champ[$j] ) {
					if ((strpos($champ[$j],'*')) === false) {
						$sql .= ",'".addslashes($chp[$j])."'";
					} else {
						$tmp = "";
						if ( $chp[$j] ) {
							$tmp = str_replace($sepaff,$seprep,$chp[$j]);
							$tmp = $seprep.$tmp.$seprep;
						}
						$sql .= ",'".addslashes($tmp)."'";
					}
				}
			}
			$sql .= ");";
			Message($sql);
			if ( mysql_query($sql) ) {
				$ok++;
			} else {
				$pb++;
				echo "<font class='message'>-=> Enregistrement N$i : erreur n" . mysql_errno($connexion) . " - " . mysql_error($connexion) . "</font><br />\n";
			}
		}
		if ( $entete ) $entete = "";
	}
	echo "<br />".t('fiches_importees')." = <b>".$ok."</b> - ".t('fiches_exclues')." = <b>".$pb."</b><br />";
	echo t('fin_importation');
	fclose ($fd);
	unlink ($fichier);
	echo '<center><form><input class="bouton" type="button" onClick="window.parent.document.tri.submit();FermeFenetre();" value="'.t('fermer').'"></form></center></body></html>';
	exit;
}
if ( $erreur ) echo '<center><span class="requete">'.$erreur.'</span></center>';
?>
<form method="post" enctype="multipart/form-data" name="GRILLE">
<table align="center" border="0" width="100%"><tr><td>
<table class="display" width="100%" border="0" cellspacing="1" cellpadding="0">
	<tr><th colspan="2">
		<?php echo t('importation_vers_lexique')." : ".$table; ?>
	</th></tr>
	<tr><td colspan="2"><?php echo t('fichier_upload'); ?> <input style="width:300px" type="file" name="import_file"><br /><?php echo sprintf(t('taille_max_upload'),MAXUPLOAD); ?></td></tr>
	<tr><td colspan="2"><input type="checkbox" name="entete" value="oui" checked><?php echo t('exclure_entete'); ?></td></tr>
	<tr>
		<td><?php echo t('separateur_champs'); ?> <input type="text" name="sepchp" value="" size="4"> <?php echo t('separateur_champs_defaut'); ?></td>
		<td><?php echo t('separateur_fiches'); ?> <input type="text" name="seprec" value="" size="4"> <?php echo t('separateur_fiches_defaut'); ?></td>
	</tr>
</table>
<table width="100%" border="0">
	<tr><td>
		<?php echo t('infos_caracteres'); ?>	
	</td></tr>
	<tr><td align="right">
		<input class="bouton" type="button" onClick="FermeFenetre();" value="<?php echo t('fermer'); ?>">&nbsp;
		<input class="bouton" type="button" onClick="if ( !document.GRILLE.import_file.value ) {alert('<?php echo t('fichier_upload_inconnu',false); ?>');} else {document.GRILLE.submit();}" value="<?php echo t('transferer_fichier'); ?>">
	</td></tr>
</table>
<input type="hidden" name="etape" value="Analyse">
<input type="hidden" name="table" value="<?php echo $table; ?>">
</form>
</body>
</html>