<?php
$restreint = true;
require_once("init.php");

// LECTURE VARIABLES TRANSMISES
$etape = LireVariable("etape","");
$sepchp = LireVariable("sepchp","\t");
$seprec = LireVariable("seprec","\r\n");
$entete = LireVariable("entete","");
$fichier = LireVariable("fichier","");
$champs = LireVariable("champs","");
$total = LireVariable("total",0);
$table = LireVariable("table","");
$format = LireVariable("format","");
$url = LireVariable("url","");
$trace = LireVariable("trace",0);

// ENTETE HTML
include("include/header.php");
if ( $table == "te_operation_tmp"  ) echo "<h1>".t('importation_base_operations')."</h1>";
if ( $table == "te_ressource_tmp"  ) echo "<h1>".t('importation_base_ressources')."</h1>";

// CONSTANTES
$erreur = "";
$sepwrk = "";

// SEPARATEURS NON AFFICHABLES
$sepchp = str_replace('\t',"\t",$sepchp);
$sepchp = str_replace('\r',"\r",$sepchp);
$sepchp = str_replace('\n',"\n",$sepchp);
$seprec = str_replace('\t',"\t",$seprec);
$seprec = str_replace('\r',"\r",$seprec);
$seprec = str_replace('\n',"\n",$seprec);

// CHARGE BORDEREAU
if ( $etape && ( $format == "ascii" || $format == "csv" ) ) {
	$bordereau = str_replace("_tmp","",$table);
	$bordereau = str_replace("te_","import_",$bordereau);
	if (!file_exists("bordereaux/$lang/".$bordereau.".php")) {
		echo t('bordereau_inconnu')." <b>[".$bordereau.".php]</b>.<br />";
		exit;
	}
	include("bordereaux/$lang/".$bordereau.".php");
}

// ETAPE 1 = PHASE D'ANALYSE
if ( $etape == "Analyse" && isset($_FILES['import_file'])) {
	
	// RECUPERATION DU FICHIER
	$dossier = 'tmp/';
	$fichier = basename($_FILES['import_file']['name']);
	$taille = filesize($_FILES['import_file']['tmp_name']);
	$extension = strrchr($_FILES['import_file']['name'], '.');
	if( $extension != ".xml" && $extension != ".txt" && $extension != ".csv" && $extension != ".rdf" ) {
     $erreur = sprintf(t('extension_interdite'),".txt,.csv,.rdf,.xml");
	} elseif ( $taille > MAXUPLOAD ) {
     $erreur = sprintf(t('fichier_trop_grand'),MAXUPLOAD);
	} else { 
		$fichier = "fic".date("Y-m-d-H-i-s").$extension; // NOM DE FICHIER TEMPORAIRE
    if( move_uploaded_file($_FILES['import_file']['tmp_name'], $dossier . $fichier) ) {
      echo t('upload_ok');
    } else {
      echo t('upload_pb');
      $erreur = t('transfert_echoue');
    }
	}
	if ( !$erreur ) {
		if ( $format == "ddi" || $format == "rdf" ) {
			// FORMULAIRE
			echo '<form method="post" name="GRILLE">';
			echo '<input type="hidden" name="etape" value="Importation">';
			echo '<input type="hidden" name="format" value="'.$format.'">';
			echo '<input type="hidden" name="table" value="'.$table.'">';
			echo '<input type="hidden" name="url" value="'.$url.'">';
			echo '<input type="hidden" name="fichier" value="'.$dossier.$fichier.'">';	
			echo '<input class="bouton" type="button" onClick="document.GRILLE.submit();" value="'.t('lancer_importation').'">&nbsp;';
			if ( $url ) {
				echo "<input class=\"bouton\" type=\"button\" onClick=\"window.location.href='".addslashes($url)."';\" value=\"".t('abandonner')."\">";
			} else {
				echo "<input class=\"bouton\" type=\"button\" onClick=\"FermeFenetre();\" value=\"".t('abandonner')."\">";
			}
			echo '</form>';
		} else {		
			// OUVERTURE DU FICHIER
			$fd = fopen ($dossier.$fichier , "r");

			// LECTURE DU PREMIER RECORD
			if ( $format == "csv" ) {
				$champ = fgetcsv($fd);			
			} else {
				$record = stream_get_line($fd, 10000, $seprec); 
				$champ = explode($sepchp,$record);
			}
			fclose ($fd);
			
			// FORMULAIRE
			echo '<form method="post" name="GRILLE">';
			echo '<input type="hidden" name="etape" value="Importation">';
			echo '<input type="hidden" name="trace" value="'.$trace.'">';
			echo '<input type="hidden" name="format" value="'.$format.'">';
			echo '<input type="hidden" name="sepchp" value="'.$sepchp.'">';
			echo '<input type="hidden" name="seprec" value="'.$seprec.'">';
			echo '<input type="hidden" name="table" value="'.$table.'">';
			echo '<input type="hidden" name="url" value="'.$url.'">';
			echo '<input type="hidden" name="entete" value="'.$entete.'">';
			echo '<input type="hidden" name="fichier" value="'.$dossier.$fichier.'">';	
			echo '<input type="hidden" name="total" value="'.count($champ).'">';	
			echo '<input type="hidden" name="champs" value="">';		

			// MAPPING
			echo '<table align="center" border="0" width="100%"><tr><td>';
			echo (count($champ))." ".t('colonne_reconnue')."<br />";
			echo '<table width="100%" align="center" class="display" bgcolor="#f2f2f2">';
			echo '<tr><th width="48%">'.t('element_reconnu').'</th><th></th><th width="48%">'.t('transferer_dans').'</th></tr>';
			
			// LISTE DES COLONNES RECONNUES PREMIER RECORD
			echo '<tr><td><select size="8" id="source" name="source" style="width: 100%;">';
			for ( $i=0; $i < count($champ); $i++) echo '<option value="'.($i+1).'">'.t('colonne').($i+1).' : '.$champ[$i].'</option>';
			echo '</select></td><td></td><td><select size="8" name="but" id="but" onClick="Repetitif(\'but\');" style="width: 100%;">';	
			
			// LISTE DES CHAMPS DISPONIBLES
			foreach ($modele as $v) {
				if ( $v["input"] != "hidden" && $v["input"] != "genere" ) {
					$flg = ( $v['sep'] == 1 ) ? "*" : "";
					if ( $v["souschamp"] ) {
						$sslib = explode("|",$v["souschamp"]);
						$sschp = explode("|",$v["input"]);
						echo "<optgroup label=\"".$v["libelle"]."\">\n";
						for ( $j=0; $j < count($sslib); $j++) echo "<option value=\"".$v["chp"].$flg."{".$sschp[$j]."}\">".$sslib[$j]."</option>\n";
						echo "</optgroup>\n";
					} else {
						echo  "<option value=\"".$v["chp"].$flg."\">".$v["libelle"];
						if ( $flg ) echo " ($flg)";
						echo "</option>\n";
					}
				}
			}
			echo '</select></td></tr>';
			echo '<tr><td colspan="3" align="center">'.t('definir_relation').'</td></tr>';
			echo '<tr><td></td><td align="center"><a href="javascript:void(0);" onClick="Prendre(\'source\',\'but\',\'afaire\');"><img src="images/fleche-vers-bas.png" border="0"></a></td>';
			echo '<td align="right"><div id="repetitif" style="display: none;">'.sprintf(t('article_repetitif'),$sepaff).' <input type="text" id="separt" name="separt" value="'.$sepaff.'" size="1" maxlength="2"></div></td></tr>';	
			
			// LISTE DES TRAITEMENTS
			if ( $entete ) echo '<tr><td colspan="3" align="center"><i>'.t('elements_identifies').'</i></td></tr>';
			echo '<tr><th colspan="3">'.t('liste_affectations').'</th></tr>';
			echo '<tr><td colspan="3"><select size="8" name="afaire" id="afaire" onDblClick="Rejeter(\'afaire\');" style="width: 100%;">';	
			
			// IDENTIFICATION AUTOMATIQUE
			if ( $entete ) {
				for ( $i=0; $i < count($champ); $i++) {
					$tmp = strtoupper(trim($champ[$i]));
					$tmp = strtr($tmp, "ݟ","AAAAAACEEEEIIIIOOOOOUUUUDYYNN"); 
					foreach ($modele as $v) {
						if ( $v["input"] != "hidden" && $v["input"] != "genere" ) {
							$flg = ( $v['sep'] == 1 ) ? "*" : "";
							if ( $v["souschamp"] ) {
								$sslib = explode("|",$v["souschamp"]);
								$sschp = explode("|",$v["input"]);
								for ( $j=0; $j < count($sslib); $j++) {
									$nom = strtoupper(trim($sslib[$j]));
									$nom = strtr($nom, "ݟ","AAAAAACEEEEIIIIOOOOOUUUUDYYNN"); 
									if ( $nom == $tmp ) echo '<option value="'.($i+1).'|'.$v["chp"].$flg.'{'.$sschp[$j].'}">'.t('colonne').($i+1).' : '.$sslib[$j].'&nbsp;&nbsp;&nbsp;&nbsp; -= '.t('transferer_dans').' => &nbsp;&nbsp;&nbsp;&nbsp;'.$sslib[$j].'</option>';
								}
							} else {
								$nom = strtoupper(trim($v["libelle"]));
								$nom = strtr($nom, "ݟ","AAAAAACEEEEIIIIOOOOOUUUUDYYNN"); 
								if ( $nom == $tmp ) {
									if ( $v['sep'] == 1 ) {
										echo '<option value="'.($i+1).'|'.$v["chp"].$flg.'['.$sepaff.']">'.t('colonne').($i+1).' : '.$champ[$i].'&nbsp;&nbsp;&nbsp;&nbsp; -= '.t('transferer_dans').' => &nbsp;&nbsp;&nbsp;&nbsp;'.$v["libelle"].' '.sprintf(t('separateur_article'),$sepaff).'</option>';
									} else {
										echo '<option value="'.($i+1).'|'.$v["chp"].$flg.'">'.t('colonne').($i+1).' : '.$champ[$i].'&nbsp;&nbsp;&nbsp;&nbsp; -= '.t('transferer_dans').' => &nbsp;&nbsp;&nbsp;&nbsp;'.$v["libelle"].'</option>';
									}
								}
							}
						}
					}
				}
			}
			echo '</select></td></tr>';	
			echo '<tr><td colspan="3">';
			echo '<input type="button" class="bouton" onClick="document.getElementById(\'afaire\').innerHTML=null;" value="'.t('supprimer_affectation').'">&nbsp;';
			echo '<font class="info">'.t('supprime').'</font>';
			echo '</td></tr>';
			echo '<tr><th colspan="3">'.t('automatique').'</th></tr><tr><td colspan="3">';
			foreach ($modele as $v) {
				if ( $v["input"] == "genere" || $v["input"] == "hidden" ) echo $v["libelle"]." -=> ".$v["choix"]."<br />";
			}
			echo '</td></tr></table></td></tr>';
			echo '<tr><td align="right"><input class="bouton" type="button" onClick="Valider(\'afaire\');" value="'.t('lancer_importation').'">&nbsp;';
			if ( $url ) {
				echo "<input class=\"bouton\" type=\"button\" onClick=\"window.location.href='".addslashes($url)."';\" value=\"".t('abandonner')."\">";
			} else {
				echo "<input class=\"bouton\" type=\"button\" onClick=\"FermeFenetre();\" value=\"".t('abandonner')."\">";
			}
			echo '</td></tr></table></form>';
?>
<script type="text/javascript">
<!--
// CHAMP REPETITIF ?
function Repetitif(LST) {
	var liste = document.getElementById(LST);
	if (liste.options.selectedIndex<0) return false;
	var tmp = liste.options[liste.options.selectedIndex].text;	
	if (tmp.substr(tmp.length-3)=="(*)") {
		document.getElementById('repetitif').style.display = 'block'
	} else {
		document.getElementById('repetitif').style.display = 'none'
	}
}	
// VALIDER
function Valider(LST) {
	var liste = document.getElementById(LST);
	if ( !liste.length ) {
		alert("<?php echo t('traitement_absent'); ?>");
		return;
	}
	var choix = "";
	for (i=0;i<liste.length;i++) {
		if ( choix ) choix = choix + "<?php echo $sepwrk; ?>";
		choix = choix + liste.options[i].value;
	}
	document.GRILLE.champs.value = choix;
	document.GRILLE.submit();
}
// REJET D'UN TERME
function Rejeter(LST) {
	var liste = document.getElementById(LST);
	var i = liste.options.selectedIndex;
	if (i<0) return;
	liste.options[liste.options.selectedIndex]=null;
	if ( !liste.length ) return;
	if ( i == liste.length ) i--;
	liste.options.selectedIndex = i;
}
// EXISTE DEJA ?
function ExisteDeja(Valeur, blnAlerte, LST) {
	var objListe = document.getElementById(LST);
	for (i=objListe.length-1;i>=0;i--) if (objListe.options[i].value == Valeur) {if (blnAlerte) alert("<?php echo t('existe_deja',false); ?>"); return true;}
	return false;
}
// PRENDRE UN TERME
function Prendre(SRC,BUT,WRK) {
	var objSrc = document.getElementById(SRC);
	var objBut = document.getElementById(BUT);
	var objWrk = document.getElementById(WRK);
	if (objSrc.options.selectedIndex<0 || objBut.options.selectedIndex<0) return false;
	var tmp = objBut.options[objBut.options.selectedIndex].text;
	var sepval = "";
	var seplib = "";
	if (tmp.substr(tmp.length-3)=="(*)") {
		sepval = document.getElementById('separt').value;
		if ( !sepval ) sepval = "<?php echo $sepaff; ?>";
		seplib = " (sparateur d'articles "+sepval+")";
		sepval = "["+sepval+"]";
	}
	var tmp = objSrc.options[objSrc.options.selectedIndex].value+"|"+objBut.options[objBut.options.selectedIndex].value+sepval;
	if (ExisteDeja(tmp, true, WRK)) return false;
	var lib = objSrc.options[objSrc.options.selectedIndex].text+"					-= <?php echo t('transferer_dans'); ?> =>					"+objBut.options[objBut.options.selectedIndex].text+seplib;
	objWrk.options[objWrk.length]=new Option(lib, tmp);
}
//-->
</script>
		<?php
		}
		echo '</body></html>';
		exit;
	}
}

// ETAPE 2 = PHASE D'IMPORTATION
if ( $etape == "Importation" ) {

	if ( $format == "ddi" || $format == "rdf" ) {	// FORMATS XML RDF / DDI

		// CHARGE BORDEREAU
		if (!file_exists("bordereaux/$lang/import_".$format.".php")) {
			echo t('bordereau_inconnu')." [import_".$format."].<br />";
			exit;
		}
		include("bordereaux/$lang/import_".$format.".php");
		
		// CREATION TABLEAU ASSOCIATIF
		$tableau = array();
		foreach ($modele as $v) {
			if ( $v["balise"] ) {
				$tmp = $v["balise"];
				$tableau["$tmp"] = "";
			}
		}	

    $parseurXML = xml_parser_create();
    $BaliseEnCours = "";
		$ok = 0;
		$pb = 0;
   	/*
 		xml_parser_set_option($parseurXML,XML_OPTION_TARGET_ENCODING, "ISO-8859-1" );
    xml_parser_set_option($parseurXML,XML_OPTION_TARGET_ENCODING,"UTF-8"); 
    xml_parser_set_option($parseurXML,XML_OPTION_SKIP_WHITE,1); 
		*/
    xml_parser_set_option($parseurXML,XML_OPTION_CASE_FOLDING,1); 
    xml_set_element_handler($parseurXML, "OuvreBalise", "FermeBalise");
    xml_set_character_data_handler($parseurXML, "ContenuBalise");

    $fd = fopen($fichier, "r");
    if (!$fd) die("Impossible d'ouvrir le fichier XML");
		$flag = false;
    while ( $ligneXML = fgets($fd, 10000)) {
    	if (!xml_parse($parseurXML, $ligneXML, feof($fd))) die(sprintf("XML error: %s at line %d", xml_error_string(xml_get_error_code($parseurXML)), xml_get_current_line_number($parseurXML)));
    }
    xml_parser_free($parseurXML);
    
	} else {	// FORMATS ASCII DELIMITE ET CSV
			
		function Decoupe($chaine) {
			global $num, $zon, $sep, $rep, $ssc, $sepaff;
			$i = strpos($chaine, "|");
			$num = intval(substr($chaine,0,$i));
			$zon = substr($chaine,$i+1);
			if ( strpos( $zon , '*' ) === false ) {$rep = false;} else {$rep = true;}
			$zon = str_replace("*","",$zon);
			$i = strpos($zon, "{");
			if ( $i === false ) {
				$ssc = "";
			} else {
				$ssc = substr($zon,$i+1);
				$ssc = str_replace("}","",$ssc);
				if ( !$ssc ) $ssc = "*";
				$zon = substr($zon,0,$i);
			}
			$i = strpos($zon, "[");
			if ( $i === false ) {
				$sep = "";
			} else {
				$sep = substr($zon,$i+1);
				$sep = str_replace("]","",$sep);
				if ( !$sep ) $sep = $sepaff;
				$zon = substr($zon,0,$i);
			}
		}
	
		if ( !$champs ) {
			echo "<font class='message'>".t('operation_annulee')."</font><br /><br />";
			echo '<form><center><input type="button" class="bouton" onClick="window.location.href=\'accueil.php\';" value="'.t('suivant').'"></center></form></body></html>';
			exit;
		}
		$champ = explode($sepwrk,$champs);
		// LISTE DES CHAMPS
		$liste = "";
		// CREATION TABLEAU ASSOCIATIF DES CONTENUS
		$contenu = array(); 
		$num = 0;	$zon = ""; $sep = ""; $rep = false; $ssc = "";
		for ( $i=0; $i < count($champ); $i++) {
			Decoupe($champ[$i]);
			if (!array_key_exists($zon, $contenu)) {
				$contenu["$zon"] = "";
				if ( $liste ) $liste .= ",";
				$liste .= $zon;
			}
		}	
		// AJOUT VALEURS PAR DEFAUT
		$defaut = "";
		foreach ($modele as $v) {
			if ( $v["input"] == "hidden" ) {
				$liste .= ",".$v["chp"];
				$defaut .= ",'".addslashes(addslashes($v["choix"]))."'";
			}
		}	
		// AJOUT VALEURS GENEREES
		foreach ($modele as $v) {
			if ( $v["input"] == "genere" ) $liste .= ",".$v["chp"];
		}	
		// DEBUT CHARGEMENT	
		ignore_user_abort();
		//set_time_limit(500);
		ob_end_flush();

		$fd = fopen ($fichier , "r");
		$pb = 0;
		$ok = 0;
		$lu = 0;

		while (!feof ($fd)) {
			if ( $format == "csv" ) {
				$chp = fgetcsv($fd);
			} else {
				$record = stream_get_line($fd, 10000, $seprec); 
				$chp = explode($sepchp,$record);
			}
			$lu++;
			if ( $trace ) {
				for ( $i=0; $i < count($chp); $i++) echo "$i : ".$chp[$i]."<br />";
				echo "<hr>";
			}
			if ( count($chp) == 1 && trim($chp[0]) == "" ) {
			} elseif ( count($chp) != $total ) {
				echo "<font class='message'>-=> Record n$lu : ".t('nombre_colonnes_incorrect')." - ".(count($chp))." - ".(count($champ))."</font><br />";
				$pb++;
			} elseif ( !$entete ) {
				// VIDER TABLEAU CONTENU
				foreach($contenu as $key => $valeur) $contenu["$key"] = "";
				$sql = "INSERT INTO $table ($cle,$liste) VALUES (0";
				
				// BOUCLE LECTURE DES COLONNES A GARDER
				for ( $i=0; $i < count($champ); $i++) {
					Decoupe($champ[$i]);
					$tmp = $chp[$num-1];
					if ( $tmp ) {
						$tmp = str_replace("","'",$tmp);
						if ( $ssc && $ssc != "*" ) $tmp = $sepssd.$ssc.$sepssf.$tmp;
						if ( $contenu["$zon"] && !$ssc ) $contenu["$zon"] .= ( $rep ) ? $sep : " - ";
						if ( $ssc == "*" ) {
							$contenu["$zon"] = $tmp.$contenu["$zon"];	
						} else {
							$contenu["$zon"] .= $tmp;	
						}
						if ( $rep ) {
							$tmp = $contenu["$zon"];
							if ( $ssc ) {
								$tmp = str_replace($seprep,"",$tmp);
								$tmp = $seprep.$tmp.$seprep;
							} else {
								$tmp = trim(str_replace($sep,$seprep,$tmp));
								$tmp = preg_replace("/ *\\$seprep */", $seprep, $tmp); 
								$tmp = $seprep.$tmp.$seprep;
								$tmp = str_replace($seprep.$seprep,$seprep,$tmp);
							}
							$contenu["$zon"] = $tmp;	
						}
					}
				}
				foreach($contenu as $key => $valeur) {
					$sql .= ",'".addslashes(addslashes($valeur))."'";	
				}	
				// AJOUT VALEURS GENEREES
				$genere = "";
				foreach ($modele as $v) {
					if ( $v["input"] == "genere" ) {
						$tmp = $v['choix'];
						eval( "\$tmp = $tmp;" );
						$genere .= ",'".addslashes(addslashes($tmp))."'";
					}
				}	
				$sql .= $defaut . $genere . ");";
				Message($sql);
				if ( mysql_query($sql) ) {
					$ok++;
				} else {
					$pb++;
					echo "<font class='message'>-=> Record N$i : erreur n" . mysql_errno($connexion) . " - " . mysql_error($connexion) . "</font><br />\n";
				}
			}
			if ( $entete ) $entete = "";
		}
	}
	echo "<br />".t('fiches_importees')." = <b>".$ok."</b> - ".t('fiches_exclues')." = <b>".$pb."</b><br />";
	echo t('fin_importation');
	if ( $ok ) echo "";
	if ( $url ) {
		echo '<a class="bouton" href="'.addslashes($url).'">'.t('poursuivre').'</a>';
	} else {
		echo '<form> <input type="button" class="bouton" onClick="window.parent.document.tri.submit();FermeFenetre();" value="'.t('fermer').'"></form>';
	}
	echo "</body></html>";
	fclose ($fd);
	unlink($fichier);
	
	exit;
}
if ( $erreur ) echo '<center><span class="requete">'.$erreur.'</span></center>';
?>
<form method="post" enctype="multipart/form-data" name="GRILLE">
<input type="hidden" name="table" value="<?php echo $table; ?>">
<table align="center" border="0" width="100%"><tr><td>
	<table class="display" width="100%" border="0" cellspacing="1" cellpadding="0">
		<tr><th colspan="2"><?php echo t('parametres_importation'); ?></th></tr>
		<tr>
			<td width="50%"><?php echo t('fichier_upload'); ?> <input style="width:300px" type="file" name="import_file"><br /><?php echo sprintf(t('taille_max_upload'),MAXUPLOAD); ?></td>
			<td width="50%"><?php echo t('format_fichier'); ?> <select name="format" style="width: 200px;" onChange="if (document.GRILLE.format.selectedIndex == 1)  {document.getElementById('bloc').style.display = 'block';} else {document.getElementById('bloc').style.display = 'none';}">
					<option value=""><?php echo t('choisir'); ?></option>
					<option value="ascii"><?php echo t('ascii_delimite'); ?></option>
					<option value="csv"><?php echo t('csv'); ?></option>
<?php
if ( $table == "te_operation_tmp"  ) echo "<option value=\"ddi\">".t('ddi')."</option>";
if ( $table == "te_ressource_tmp"  ) echo "<option value=\"rdf\">".t('rdf')."</option>";
?>
				</select>
			</td>
		</tr>
		<tr><td colspan="2"><input type="checkbox" value="1" name="trace"><?php echo t('mode_trace'); ?></td></tr>
		<tr><td colspan="2">
			<div id="bloc" style="width: 100%; display: none;">
			<table width="100%" border="0">
				<tr><td colspan="2"><input type="checkbox" name="entete" value="oui" checked><?php echo t('exclure_entete'); ?></td></tr>
				<tr><td colspan="2"><i><?php echo t('infos_caracteres'); ?> :</i></td></tr>
				<tr>
					<td><?php echo t('separateur_champs'); ?> <input type="text" name="sepchp" value="\t" size="4"> <?php echo t('separateur_champs_defaut'); ?></td>
					<td><?php echo t('separateur_fiches'); ?> <input type="text" name="seprec" value="\r\n" size="4"> <?php echo t('separateur_fiches_defaut'); ?></td>
				</tr>
			</table>
			</div>
			</td></tr></table>
		<table width="100%">
			<tr><td align="right">
<?php if ( $url ) { ?>
		<a class="bouton" href="<?php echo addslashes($url); ?>"><?php echo t('abandonner'); ?></a>
<?php } else { ?>
		<input class="bouton" type="button" onClick="FermeFenetre();" value="<?php echo t('abandonner'); ?>">
<?php } ?>
		<input class="bouton" type="button" onClick="if ( !document.GRILLE.import_file.value || document.GRILLE.format.selectedIndex == 0 ) {alert('<?php echo t('element_absent',false); ?>');} else {document.GRILLE.submit();}" value="<?php echo t('valider'); ?>">
			</td></tr>
</table>
<input type="hidden" name="etape" value="Analyse">
</form>
</body>
</html>
