<?php 
/*
* +----------------------------------------------------------------------+
* | PHP Version 4                                                        |
* +----------------------------------------------------------------------+
* | Copyright (c) 2002-2005 Heinrich Stamerjohanns                       |
* |                                                                      |
* | oaidp-config.php -- Configuration of the OAI Data Provider           |
* |                                                                      |
* | This is free software; you can redistribute it and/or modify it under|
* | the terms of the GNU General Public License as published by the      |
* | Free Software Foundation; either version 2 of the License, or (at    |
* | your option) any later version.                                      |
* | This software is distributed in the hope that it will be useful, but |
* | WITHOUT  ANY WARRANTY; without even the implied warranty of          |
* | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         |
* | GNU General Public License for more details.                         |
* | You should have received a copy of the GNU General Public License    |
* | along with  software; if not, write to the Free Software Foundation, |
* | Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA         |
* |                                                                      |
* +----------------------------------------------------------------------+
* | Derived from work by U. Mller, HUB Berlin, 2002                     |
* |                                                                      |
* | Written by Heinrich Stamerjohanns, May 2002                          |
* |            stamer@uni-oldenburg.de                                   |
* +----------------------------------------------------------------------+
*/
//
// $Id: oaidp-config.php,v 1.07 2004/07/01 16:59:57 stamer Exp $
//

/* 
 * This is the configuration file for the PHP OAI Data-Provider.
 * Please read through the WHOLE file, there are several things, that 
 * need to be adjusted:

 - where to find the PEAR classes (look for PEAR SETUP)
 - parameters for your database connection (look for DATABASE SETUP)
 - the name of the table where you store your data
 - the encoding your data is stored (all below DATABASE SETUP)
*/

// To install, test and debug use this	
// If set to TRUE, will die and display query and database error message
// as soon as there is a problem. Do not set this to TRUE on a production site,
// since it will show error messages to everybody.
// If set FALSE, will create XML-output, no matter what happens.
$SHOW_QUERY_ERROR = FALSE;

// The content-type the WWW-server delivers back. For debug-puposes, "text/plain" 
// is easier to view. On a production site you should use "text/xml".
//$CONTENT_TYPE = 'Content-Type: text/plain';
$CONTENT_TYPE = 'Content-Type: text/xml';

error_reporting(E_ALL & ~E_NOTICE);

// do not change
$MY_URI = 'http://'.$_SERVER['SERVER_NAME'].$_SERVER['SCRIPT_NAME'];

// MUST (only one)
// please adjust
// $repositoryName       = ''; <- DECLARE DANS config/perso_inc.php

// You can use a static URI as well.
$baseURL			  = $MY_URI;

// do not change
$protocolVersion      = '2.0';

// How your repository handles deletions
// no: 			The repository does not maintain status about deletions.
//				It MUST NOT reveal a deleted status.
// persistent:	The repository persistently keeps track about deletions 
//				with no time limit. It MUST consistently reveal the status
//				of a deleted record over time.
// transient:   The repository does not guarantee that a list of deletions is 
//				maintained. It MAY reveal a deleted status for records.
// 
// If your database keeps track of deleted records change accordingly.
// Currently if $record['deleted'] is set to 'true', $status_deleted is set.
// Some lines in listidentifiers.php, listrecords.php, getrecords.php  
// must be changed to fit the condition for your database.
$deletedRecord        = 'no'; 

// MAY (only one)
//granularity is days
$granularity          = 'YYYY-MM-DD';
// granularity is seconds
// $granularity          = 'YYYY-MM-DDThh:mm:ssZ';

// MUST (only one)
// the earliest datestamp in your repository,
// please adjust
// $earliestDatestamp    = 'xxxx-xx-xx'; <- DECLARE DANS config/perso_inc.php

// this is appended if your granularity is seconds.
// do not change
if ($granularity == 'YYYY-MM-DDThh:mm:ss:Z') $earliestDatestamp .= 'T00:00:00Z';

// MUST (multiple)
// please adjust
$adminEmail			= array($admin); 

// MAY (multiple) 
// Comment out, if you do not want to use it.
// Currently only gzip is supported (you need output buffering turned on, 
// and php compiled with libgz). 
// The client MUST send "Accept-Encoding: gzip" to actually receive 
// compressed output.
$compression		= array('gzip');

// MUST (only one)
// should not be changed
$delimiter			= ':';

// MUST (only one)
// You may choose any name, but for repositories to comply with the oai 
// format for unique identifiers for items records. 
// see: http://www.openarchives.org/OAI/2.0/guidelines-oai-identifier.htm
// Basically use domainname-word.domainname
// please adjust
// $repositoryIdentifier = '';  <- DECLARE DANS config/perso_inc.php


// description is defined in identify.php 
$show_identifier = true;

// You may include details about your community and friends (other
// data-providers).
// Please check identify.php for other possible containers 
// in the Identify response

// maximum mumber of the records to deliver
// (verb is ListRecords)
// If there are more records to deliver
// a ResumptionToken will be generated.
$MAXRECORDS = 50;

// maximum mumber of identifiers to deliver
// (verb is ListIdentifiers)
// If there are more identifiers to deliver
// a ResumptionToken will be generated.
$MAXIDS = 200;

// After 24 hours resumptionTokens become invalid.
$tokenValid = 24*3600;
$expirationdatetime = gmstrftime('%Y-%m-%dT%TZ', time()+$tokenValid); 


// define all supported metadata formats

//
// myhandler is the name of the file that handles the request for the 
// specific metadata format.
// [record_prefix] describes an optional prefix for the metadata
// [record_namespace] describe the namespace for this prefix
$METADATAFORMATS = 	array (
						'oai_dc' => array('metadataPrefix'=>'oai_dc', 
							'schema'=>'http://www.openarchives.org/OAI/2.0/oai_dc.xsd',
							'metadataNamespace'=>'http://www.openarchives.org/OAI/2.0/oai_dc/',
							'myhandler'=>'record_dc.php',
							'record_prefix'=>'dc',
							'record_namespace' => 'http://purl.org/dc/elements/1.1/'
						) 
					);

// AJOUT SETS
// define all supported sets in your repository
$SETS = 	array ();

// TYPE DE DOCUMENT
$sql = "select OAISet,GROUP_CONCAT(Terme separator ', ') as Name,Description FROM te_lex_typdoc WHERE OAISet != '' GROUP BY OAISet ORDER BY OAISet;";
$res = mysql_query($sql) or die("echec de la requete");
$total = mysql_num_rows($res);
while ( $rec = mysql_fetch_array($res) ) {
	$SETS[] = array('setSpec'=>$rec['OAISet'], 'setName'=>'Type de document : '.addslashes($rec['Name']), 'setDescription'=>$rec['Description']);	
}

// TYPE DE RESSOURCE
$sql = "select ResOAISet,GROUP_CONCAT(ResType separator ', ') as Name,ResOAIDescription FROM te_lex_ressource WHERE ResOAISet != '' GROUP BY ResOAISet ORDER BY ResOAISet;";
$res = mysql_query($sql) or die("echec de la requete");
$total = mysql_num_rows($res);
while ( $rec = mysql_fetch_array($res) ) {
	$SETS[] = array('setSpec'=>$rec['ResOAISet'], 'setName'=>'Type de ressource : '.addslashes($rec['Name']), 'setDescription'=>$rec['ResOAIDescription']);	
}

// OPERATIONS
$sql = "SELECT OpeCodeIreda,OpeTitre,OpeTitreTraduit,OpeResume FROM te_operation LEFT OUTER JOIN te_relations ON te_operation.Idope = te_relations.idope LEFT OUTER JOIN te_ressource ON te_relations.idres = te_ressource.Idres WHERE (te_operation.OpeBiblio = 0) and (te_operation.OpeStatut = 0) and (te_ressource.ResStatut = 0) GROUP BY te_operation.Idope ORDER BY te_operation.OpeCodeIreda;";
$res = mysql_query($sql) or die("echec de la requete");
$total = mysql_num_rows($res);
while ( $rec = mysql_fetch_array($res) ) {
	$SETS[] = array('setSpec'=>'operation:'.$rec['OpeCodeIreda'], 'setName'=>addslashes($rec['OpeTitre'].' = '.$rec['OpeTitreTraduit']), 'setDescription'=>addslashes($rec['OpeResume']));	
}

// the charset you store your metadata in your database
// currently only utf-8 and iso8859-1 are supported
$charset = "iso8859-1";

// if entities such as < > ' " in your metadata has already been escaped 
// then set this to true (e.g. you store < as &lt; in your DB)
$xmlescaped = false;

// We store multiple entries for one element in a single row 
// in the database. SQL['split'] ist the delimiter for these entries.
// If you do not do this, do not define $SQL['split']
$SQL['split'] = ';';

// the name of the table where your store your metadata
$SQL['table'] = 'te_ressource';

// the name of the column where you store your sequence 
// (or autoincrement values).
$SQL['id_column'] = 'Idres';

// the name of the column where you store the unique identifiers
// pointing to your item.
// this is your internal identifier for the item
$SQL['identifier'] = 'Idres';

// If you want to expand the internal identifier in some way
// use this (but not for OAI stuff, see next line)
// $idPrefix = ''; <- DECLARE DANS config/perso_inc.php

// this is your external (OAI) identifier for the item
// this will be expanded to
// oai:$repositoryIdentifier:$idPrefix$SQL['identifier']
// should not be changed
$oaiprefix = "oai".$delimiter.$repositoryIdentifier.$delimiter.$idPrefix; 

// adjust anIdentifier with sample contents an identifier
$sampleIdentifier     = $oaiprefix.'';

// the name of the column where you store your datestamps
$SQL['datestamp'] = 'ResDateCreat';

// the name of the column where you store information whether
// a record has been deleted. Leave it as it is if you do not use
// this feature.
$SQL['deleted'] = 'deleted';

// to be able to quickly retrieve the sets to which one item belongs,
// the setnames are stored for each item
// the name of the column where you store sets
$SQL['set'] = 'OAI'; 

// Here are a couple of queries which might need to be adjusted to 
// your needs. Normally, if you have correctly named the columns above,
// this does not need to be done.

// this function should generate a query which will return
// all records
// the useless condition id_column = id_column is just there to ease
// further extensions to the query, please leave it as it is.
function selectallQuery ($id = '')
{
	global $SQL;
	$query = "select *,CONCAT_WS(';',OAISet,ResOAISet,REPLACE(ResIreda,'|',';operation:')) as ".$SQL['set']." FROM te_ressource LEFT JOIN te_lex_ressource ON te_ressource.ResCodeRessource = te_lex_ressource.ResCode LEFT JOIN te_lex_typdoc ON te_ressource.Masque = te_lex_typdoc.Code WHERE ";
	if ($id == '') {
		$query .= $SQL['id_column'].' = '.$SQL['id_column'];
	}
	else {
		$query .= $SQL['identifier']." ='$id'";
	}
	return $query;
}

// this function will return identifier and datestamp for all records
function idQuery ($id = '')
{
	global $SQL;

	if ($SQL['set'] != '') {
		$query = "select ".$SQL['identifier'].",".$SQL['datestamp'].",CONCAT_WS(';',OAISet,ResOAISet,REPLACE(ResIreda,'|',';operation:')) as ".$SQL['set']." FROM te_ressource LEFT JOIN te_lex_ressource ON te_ressource.ResCodeRessource = te_lex_ressource.ResCode LEFT JOIN te_lex_typdoc ON te_ressource.Masque = te_lex_typdoc.Code WHERE ";
	} else {
		$query = 'select '.$SQL['identifier'].','.$SQL['datestamp'].' FROM '.$SQL['table'].' WHERE ';
	}
	
	if ($id == '') {
		$query .= $SQL['id_column'].' = '.$SQL['id_column'];
	}
	else {
		$query .= $SQL['identifier']." = '$id'";
	}

	return $query;
}

// filter for until
function untilQuery($until) 
{
	global $SQL;

	return ' and '.$SQL['datestamp']." <= '$until'";
}

// filter for from
function fromQuery($from)
{
	global $SQL;

	return ' and '.$SQL['datestamp']." >= '$from'";
}

// filter for sets
function setQuery($set)
{
	global $SQL;
	
	$tmp = ( preg_match("/operation:/",$set) ) ? ( str_replace("operation:","",$set) ) : $set;
	return " and (OAISet LIKE '%$tmp%' or ResOAISet LIKE '%$tmp%' or ResIreda LIKE '%|$tmp|%')" ;
}

// There is no need to change anything below.

// Current Date
// $datetime = gmstrftime('%Y-%m-%dT%T');
$datetime = gmstrftime('%Y-%m-%dT%H:%M:%S');
$responseDate = $datetime.'Z';

// do not change
$XMLHEADER = 
'<?xml version="1.0" encoding="UTF-8"?>
<OAI-PMH xmlns="http://www.openarchives.org/OAI/2.0/"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://www.openarchives.org/OAI/2.0/
         http://www.openarchives.org/OAI/2.0/OAI-PMH.xsd">'."\n";

$xmlheader = $XMLHEADER . 
			  ' <responseDate>'.$responseDate."</responseDate>\n";

// the xml schema namespace, do not change this
$XMLSCHEMA = 'http://www.w3.org/2001/XMLSchema-instance';
?>
