<?php
/*
* +----------------------------------------------------------------------+
* | PHP Version 4                                                        |
* +----------------------------------------------------------------------+
* | Copyright (c) 2002-2005 Heinrich Stamerjohanns                       |
* |                                                                      |
* | dc_record.php -- Utilities for the OAI Data Provider                 |
* |                                                                      |
* | This is free software; you can redistribute it and/or modify it under|
* | the terms of the GNU General Public License as published by the      |
* | Free Software Foundation; either version 2 of the License, or (at    |
* | your option) any later version.                                      |
* | This software is distributed in the hope that it will be useful, but |
* | WITHOUT  ANY WARRANTY; without even the implied warranty of          |
* | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         |
* | GNU General Public License for more details.                         |
* | You should have received a copy of the GNU General Public License    |
* | along with  software; if not, write to the Free Software Foundation, |
* | Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA         |
* |                                                                      |
* +----------------------------------------------------------------------+
* | Derived from work by U. Mller, HUB Berlin, 2002                     |
* |                                                                      |
* | Written by Heinrich Stamerjohanns, May 2002                          |
* /            stamer@uni-oldenburg.de                                   |
* +----------------------------------------------------------------------+
*/
//
// $Id: record_dc.php,v 1.02 2003/04/08 14:32:07 stamer Exp $
//

// this handles unqualified DC records, but can be also used as a sample
// for other formats.
// just specify the next variable according to your own metadata prefix
// change output your metadata records further below.

// please change to the according metadata prefix you use 
$prefix = 'oai_dc';

// you do need to change anything in the namespace and schema stuff
// the correct headers should be created automatically

$output .= 
'   <metadata>'."\n";

$output .= metadataHeader($prefix);

// please change according to your metadata format
$indent = 6;

// dc:title -> TITRE. NOEDITION : TITRE TRADUIT In : TITRE GENERIQUE = TITRE TRADUIT GENERIQUE 
$tmp = $record["ResTitre"];
$tmp1 = $record["ResNEdition"];
if ( $tmp && $tmp1 ) {$tmp .= '. '.$tmp1;} else {$tmp.=$tmp1;}
$tmp1 = $record["ResTitreTraduit"];
if ( $tmp && $tmp1 ) {$tmp .= ' : '.$tmp1;} else {$tmp.=$tmp1;}
$tmp1 = $record["ResTitreGenerique"];
if ( $tmp && $tmp1 ) {$tmp .= ' [In] '.$tmp1;} else {$tmp.=$tmp1;}
$tmp1 = $record["ResTitreTraduitGenerique"];
if ( $tmp && $tmp1 ) {$tmp .= ' = '.$tmp1;} else {$tmp.=$tmp1;}
$output .= xmlrecord($tmp, 'dc:title', '', $indent);
// xml:lang="eng"

// dc:creator -> AUTEURS; SIGLES; ORGANISMES
$tmp = $record["ResAuteur"];
$tmp1 = $record["ResOrganisme"];
if ( $tmp && $tmp1 ) {$tmp = $tmp."; ".$tmp1; } else { $tmp = $tmp.$tmp1; }
$tmp1 = $record["ResSigle"];
if ( $tmp && $tmp1 ) {$tmp = $tmp."; ".$tmp1; } else { $tmp = $tmp.$tmp1; }
$output .= xmlrecord($tmp,'dc:creator', '', $indent);

// dc:subject -> DESCRIPTEURS; CANDIDATS; ETHNIE
$tmp = $record["ResDescripteur"].$record["ResCandidatDescripteur"].$record["ResEthnie"];
$terme = explode("|",$tmp);
for ($i=0;$i<count($terme);$i++) {
	if ( trim($terme[$i]) ) {
		$output .= xmlrecord(trim($terme[$i]), 'dc:subject', '', $indent);
	}
}

// dc:description -> RESUME
$output .= xmlrecord($record['ResResume'], 'dc:description', '', $indent, false);

// dc:publisher -> LIEU DE PUBLICATION / EDITEUR
$tmp = $record["ResLieuEdition"];
$tmp1 = $record["ResEditeur"];
if ( $tmp && $tmp1 ) {$tmp = $tmp." : ".$tmp1; } else { $tmp = $tmp.$tmp1; }
$output .= xmlrecord($tmp, 'dc:publisher', '', $indent, false);

//$output .= xmlrecord($record['dc_contributor'], 'dc:contributor', '', $indent);

// dc:date -> DATE DE PUBLICATION
$output .= xmlrecord($record['ResDatePublication'], 'dc:date', '', $indent);

// dc:type -> IRETYPE
$output .= xmlrecord($record['ResTypeDocument'], 'dc:type', '', $indent);
//$output .= xmlrecord($record['ResIretype'], 'dc:type', '', $indent);

// dc:format -> PAGINATION - VOLUME - NUMERO - MIME TYPE
$tmp = $record["ResPagination"];
$tmp1 = $record["ResVolume"];
if ( $tmp && $tmp1 ) {$tmp = $tmp.", ".$tmp1; } else { $tmp = $tmp.$tmp1; }
$tmp1 = $record["ResNumero"];
if ( $tmp1 ) $tmp1 = "no.".$tmp1;
if ( $tmp && $tmp1 ) {$tmp = $tmp.", ".$tmp1; } else { $tmp = $tmp.$tmp1; }
$fic = trim($record["ResFIC"]);
if ( $fic ) {
	$ext = strtoupper(substr($fic,-4));
	if ( $ext == ".PDF" ) $tmp .= ";application/pdf";
	if ( $ext == ".DOC" ) $tmp .= ";application/msword";
	if ( $ext == ".ZIP" ) $tmp .= ";application/zip";
	if ( $ext == ".XLS" ) $tmp .= ";application/msexcel";
}
$output .= xmlrecord($tmp, 'dc:format', '', $indent);

// dc:identifier -> URL VERS RESSOURCE - ISSN - ISBN
$tmp = "http://".URL."format_long_ressource.php?fiche=".$record["Idres"];
if ($record['ResISSN']) $tmp .= ";".$record['ResISSN'];
if ($record['ResISBN']) $tmp .= ";".$record['ResISBN'];
$output .= xmlrecord($tmp, 'dc:identifier', '', $indent);

// dc:source -> COTE
$output .= xmlrecord($record['ResCote'], 'dc:source', '', $indent);

// dc:language -> LANGUE
$tmp = trim($record['ResLangue']);
if ( $tmp ) {
	$terme = explode(";",$tmp);
	$tmp = "";
	for ($i=0;$i<count($terme);$i++) {
		$val = preg_replace("/[^\[]+\[(\w+)\]/","\\1",trim($terme[$i]));
		if ( $val ) {
			if ( $tmp ) $tmp.= ";";
			$tmp .= $val;
		}
	}
}
$output .= xmlrecord($tmp, 'dc:language', '', $indent);

// dc:relation -> OPERATIONS DE RATTACHEMENT
$tmp = $record["ResIreda"];
$terme = explode("|",$tmp);
$tmp = "";
for ($i=0;$i<count($terme);$i++) {
	if ( trim($terme[$i]) ) {
		if( strpos( trim($terme[$i]) , '-' ) !== false ) {
			if ( $tmp ) $tmp .= ";";
			$tmp .= "Rattach  l'opration http://".URL."operations/".trim($terme[$i]);
			//$tmp .= "Rattach  l'opration http://".URL."format_liste_operation.php?Chp6=".trim($ope[$i]);
		}
	}
}
$output .= xmlrecord($tmp, 'dc:relation', '', $indent);

// dc:coverage -> PAYS - LOCALISATION
$tmp = $record["ResPays"].$record["ResLocalisation"];
$terme = explode("|",$tmp);
for ($i=0;$i<count($terme);$i++) {
	if ( trim($terme[$i]) ) {
		$output .= xmlrecord(trim($terme[$i]), 'dc:coverage', '', $indent);
	}
}

// dc:rights -> RIGHTS (dfaut domaine public / public domain)
$tmp = $record["ResRights"];
if ( !$tmp ) $tmp = "domaine public / public domain";
$output .= xmlrecord($tmp, 'dc:rights', '', $indent);

/*
$output .= xmlrecord($record['dc_title'], 'dc:title', '', $indent);
$output .= xmlrecord($record['dc_creator'],'dc:creator', '', $indent);
$output .= xmlrecord($record['dc_subject'], 'dc:subject', '', $indent);
$output .= xmlrecord($record['dc_description'], 'dc:description', '', $indent);
$output .= xmlrecord($record['dc_publisher'], 'dc:publisher', '', $indent);
$output .= xmlrecord($record['dc_contributor'], 'dc:contributor', '', $indent);
$output .= xmlrecord($record['dc_date'], 'dc:date', '', $indent);
$output .= xmlrecord($record['dc_type'], 'dc:type', '', $indent);
$output .= xmlrecord($record['dc_format'], 'dc:format', '', $indent);
$output .= xmlrecord($record['dc_identifier'], 'dc:identifier', '', $indent);
$output .= xmlrecord($record['dc_source'], 'dc:source', '', $indent);
$output .= xmlrecord($record['dc_language'], 'dc:language', '', $indent);
$output .= xmlrecord($record['dc_relation'], 'dc:relation', '', $indent);
$output .= xmlrecord($record['dc_coverage'], 'dc:coverage', '', $indent);
$output .= xmlrecord($record['dc_rights'], 'dc:rights', '', $indent);
*/

// Here, no changes need to be done
$output .=           
'     </'.$prefix;
if (isset($METADATAFORMATS[$prefix]['record_prefix'])) {
	$output .= ':'.$METADATAFORMATS[$prefix]['record_prefix'];
}
$output .= ">\n";
$output .= 
'   </metadata>'."\n";
?>
